View Issue Details

IDProjectCategoryView StatusLast Update
0032612Open CASCADEOCCT:Data Exchangepublic2021-10-18 14:04
Reporterkgv Assigned Tosmoskvin  
PrioritynormalSeverityminor 
Status closedResolutionfixed 
Product Version7.5.0 
Target Version7.6.0Fixed in Version7.6.0 
Summary0032612: Data Exchange, RWGltf_CafReader - lost hierarchy of two nested compounds
DescriptionReading glTF containing nested scene nodes with a single child leads to lost hierarchy details in produced XCAF document.
Steps To Reproduce
pload MODELING OCAF XDE VISUALIZATION
box b 1 2 3
incmesh b 0.1
compound b c
compound c cc
XNewDoc D1
XAddShape D1 cc
SetName D1 [XFindShape D1 b]    "box"
SetName D1 [XFindShape D1 c]    "comp1"
SetName D1 [XFindShape D1 c]:1  "box_inst"
SetName D1 [XFindShape D1 cc]   "comp2"
SetName D1 [XFindShape D1 cc]:1 "comp1_inst"
XSave D1 "test.xbf"
WriteGltf D1 "test.glb"

ReadGltf D "test.glb"
Xdump D


Output:
INSTANCE COMPOUND 0:1:1:1 (refers to 0:1:1:2) "comp2"
PART COMPOUND 0:1:1:2 "box"

Free Shapes: 1
INSTANCE COMPOUND  0:1:1:1 (refers to 0:1:1:2) "comp2"
TagsNo tags attached.
Test case numberde_mesh/gltf_write/compound

Attached Files

  • cadass_box_xbf_OK.png (22,057 bytes)
  • cadass_box_glb_KO.png (24,519 bytes)
  • bug32612.glb (3,304 bytes)
  • cadass_box_glb_patch_OK.png (23,366 bytes)

Relationships

child of 0030691 closedbugmaster Data Exchange - implement import of mesh data from files in glTF format 

Activities

kgv

2021-10-11 22:51

developer  

cadass_box_xbf_OK.png (22,057 bytes)

kgv

2021-10-11 22:51

developer  

cadass_box_glb_KO.png (24,519 bytes)

git

2021-10-11 22:54

administrator   ~0104592

Branch CR32612 has been created by kgv.

SHA-1: 5892c014b0afdce6a96aef25f7bced25917fed14


Detailed log of new commits:

Author: kgv
Date: Mon Oct 11 22:05:58 2021 +0300

    0032612: Data Exchange, RWGltf_CafReader - lost hierarchy of two nested compounds
    
    Added comparisons with reference Xdump data to glTF tests.

kgv

2021-10-11 22:55

developer  

bug32612.glb (3,304 bytes)

kgv

2021-10-11 23:02

developer  

cadass_box_glb_patch_OK.png (23,366 bytes)

git

2021-10-11 23:44

administrator   ~0104593

Branch CR32612 has been updated by kgv.

SHA-1: f4848919443fc735b8f75b6d239be386c858158e


Detailed log of new commits:

Author: kgv
Date: Mon Oct 11 23:24:52 2021 +0300

    RWGltf_GltfJsonParser::gltfParseSceneNode() - prevent flattering of Scene nodes
    (allow flattering only of Mesh nodes).
    
    Added command XAutoNaming managing XCAFDoc_ShapeTool::SetAutoNaming().

git

2021-10-11 23:44

administrator   ~0104594

Branch CR32612_1 has been created by kgv.

SHA-1: 1fa7e7081d48597df56e718e201a7d3f235151e5


Detailed log of new commits:

Author: kgv
Date: Mon Oct 11 22:05:58 2021 +0300

    0032612: Data Exchange, RWGltf_CafReader - lost hierarchy of two nested compounds
    
    RWGltf_GltfJsonParser::gltfParseSceneNode() - prevent flattering of Scene nodes
    (allow flattering only of Mesh nodes).
    
    Added command XAutoNaming managing XCAFDoc_ShapeTool::SetAutoNaming().
    Added comparisons with reference Xdump data to glTF tests.

kgv

2021-10-12 00:54

developer   ~0104595

Patch is ready for review
- OCCT: branch CR32612_1.

http://jenkins-test-12.nnov.opencascade.com:8080/view/CR32612_1-master-KGV/

git

2021-10-12 07:39

administrator   ~0104596

Branch CR32612_1 has been updated forcibly by kgv.

SHA-1: e9eae66b7384ad58d751aa227fd2349af531bcf8

osa

2021-10-12 13:02

developer   ~0104603

The patch was reviewed

smoskvin

2021-10-16 10:03

administrator   ~0104660

Combination -
OCCT branch : IR-2021-10-15
master SHA - 475da0f1352e60eebf1432cf136042444c7c5488
49e51745631c52b6c452c65adae4d6dfa21a1b1e
Products branch : IR-2021-10-15 SHA - bd88028c52a28c63c191e235d0af754d59b66c81
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian80-64:
OCCT
Total CPU difference: 17699.720000000394 / 17936.010000000137 [-1.32%]
Products
Total CPU difference: 11665.880000000112 / 11621.340000000107 [+0.38%]
Windows-64-VC14:
OCCT
Total CPU difference: 19656.34375 / 19690.109375 [-0.17%]
Products
Total CPU difference: 12872.390625 / 12807.375 [+0.51%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention

git

2021-10-16 11:46

administrator   ~0104681

Branch CR32612 has been deleted by mnt.

SHA-1: f4848919443fc735b8f75b6d239be386c858158e

git

2021-10-16 11:46

administrator   ~0104682

Branch CR32612_1 has been deleted by mnt.

SHA-1: e9eae66b7384ad58d751aa227fd2349af531bcf8

Related Changesets

occt: master 16f9b46d

2021-10-11 19:05:58

kgv


Committer: smoskvin Details Diff
0032612: Data Exchange, RWGltf_CafReader - lost hierarchy of two nested compounds

RWGltf_GltfJsonParser::gltfParseSceneNode() - prevent flattering of Scene nodes
(allow flattering only of Mesh nodes).

Added command XAutoNaming managing XCAFDoc_ShapeTool::SetAutoNaming().
Added comparisons with reference Xdump data to glTF tests.
Affected Issues
0032612
mod - src/RWGltf/RWGltf_GltfJsonParser.cxx Diff File
mod - src/XDEDRAW/XDEDRAW_Shapes.cxx Diff File
mod - src/XSDRAWSTLVRML/XSDRAWSTLVRML.cxx Diff File
mod - tests/de_mesh/begin Diff File
mod - tests/de_mesh/gltf_read/boxinterleaved Diff File
mod - tests/de_mesh/gltf_read/brainstem Diff File
mod - tests/de_mesh/gltf_read/buggy Diff File
mod - tests/de_mesh/gltf_read/cubeemb Diff File
mod - tests/de_mesh/gltf_read/engine Diff File
mod - tests/de_mesh/gltf_read/helmet Diff File
mod - tests/de_mesh/gltf_read/lantern Diff File
mod - tests/de_mesh/gltf_read/launchvehicle Diff File
mod - tests/de_mesh/gltf_read/orient Diff File
mod - tests/de_mesh/gltf_write/as1 Diff File
mod - tests/de_mesh/gltf_write/ball Diff File
add - tests/de_mesh/gltf_write/compound Diff File
mod - tests/de_mesh/gltf_write/empty Diff File
mod - tests/de_mesh/gltf_write/helmet Diff File
mod - tests/de_mesh/gltf_write/helmetglb Diff File
mod - tests/de_mesh/gltf_write/lantern Diff File
mod - tests/de_mesh/gltf_write/lanternglb Diff File

Issue History

Date Modified Username Field Change
2021-10-11 22:51 kgv New Issue
2021-10-11 22:51 kgv Assigned To => kgv
2021-10-11 22:51 kgv File Added: cadass_box_xbf_OK.png
2021-10-11 22:51 kgv File Added: cadass_box_glb_KO.png
2021-10-11 22:54 git Note Added: 0104592
2021-10-11 22:55 kgv File Added: bug32612.glb
2021-10-11 23:02 kgv File Added: cadass_box_glb_patch_OK.png
2021-10-11 23:44 git Note Added: 0104593
2021-10-11 23:44 git Note Added: 0104594
2021-10-12 00:54 kgv Test case number => de_mesh/gltf_write/compound
2021-10-12 00:54 kgv Note Added: 0104595
2021-10-12 00:54 kgv Assigned To kgv => osa
2021-10-12 00:54 kgv Status new => resolved
2021-10-12 07:39 git Note Added: 0104596
2021-10-12 13:02 osa Note Added: 0104603
2021-10-12 13:02 osa Assigned To osa => bugmaster
2021-10-12 13:02 osa Status resolved => reviewed
2021-10-16 10:03 smoskvin Note Added: 0104660
2021-10-16 10:03 smoskvin Status reviewed => tested
2021-10-16 11:13 smoskvin Changeset attached => occt master 16f9b46d
2021-10-16 11:13 smoskvin Assigned To bugmaster => smoskvin
2021-10-16 11:13 smoskvin Status tested => verified
2021-10-16 11:13 smoskvin Resolution open => fixed
2021-10-16 11:46 git Note Added: 0104681
2021-10-16 11:46 git Note Added: 0104682
2021-10-18 14:04 kgv Relationship added child of 0030691